"use strict";
// Copyright 2024 Gnuxie <Gnuxie@protonmail.com>
//
// SPDX-License-Identifier: Apache-2.0
//
// SPDX-FileAttributionText: <text>
// This modified file incorporates work from @the-draupnir-project/interface-manager
// https://github.com/the-draupnir-project/interface-manager
// </text>
Object.defineProperty(exports, "__esModule", { value: true });
exports.isPartialCommand = isPartialCommand;
exports.isCompleteCommand = isCompleteCommand;
exports.makePartialCommand = makePartialCommand;
function isPartialCommand(command) {
    return command.isPartial;
}
function isCompleteCommand(command) {
    return !command.isPartial;
}
function makePartialCommand(stream, commandDescription, commandTable, designator) {
    return {
        stream,
        isPartial: true,
        description: commandDescription,
        designator,
        commandTable,
    };
}
//# sourceMappingURL=Command.js.map