"use strict";
// SPDX-FileCopyrightText: 2023 - 2025 Gnuxie <Gnuxie@protonmail.com>
//
// SPDX-License-Identifier: Apache-2.0
//
// SPDX-FileAttributionText: <text>
// This modified file incorporates work from matrix-basic-types
// https://github.com/the-draupnir-project/matrix-basic-types
// </text>
Object.defineProperty(exports, "__esModule", { value: true });
exports.isStringRoomID = isStringRoomID;
exports.StringRoomID = StringRoomID;
exports.roomIDServerName = roomIDServerName;
const StringRoomIDRegex = /^![^:]*:(?<serverName>\S*)/;
function isStringRoomID(string) {
    return StringRoomIDRegex.test(string);
}
function StringRoomID(value) {
    if (typeof value === "string" && isStringRoomID(value)) {
        return value;
    }
    throw new TypeError("Not a valid StringRoomID");
}
function roomIDServerName(roomID) {
    var _a, _b;
    const match = (_b = (_a = StringRoomIDRegex.exec(roomID)) === null || _a === void 0 ? void 0 : _a.groups) === null || _b === void 0 ? void 0 : _b.serverName;
    if (match === undefined) {
        throw new TypeError("Somehow a StringRoomID was created that is invalid");
    }
    return match;
}
//# sourceMappingURL=StringRoomID.js.map