import { EDStatic } from 'matrix-protection-suite';
export interface RoomListQueryParams {
    from?: number;
    limit?: number;
    order_by?: 'alphabetical' | 'size' | 'name' | 'canonical_alias' | 'joined_members' | 'joined_local_members' | 'version' | 'creator' | 'encryption' | 'federatable' | 'public' | 'join_rules' | 'guest_access' | 'history_visibility' | 'state_events';
    dir?: 'f' | 'b';
    search_term?: string;
    public_rooms?: boolean;
    empty_rooms?: boolean;
}
export type RoomListResponse = EDStatic<typeof RoomListResponse>;
export declare const RoomListResponse: import("@sinclair/typebox").TObject<{
    rooms: import("@sinclair/typebox").TArray<import("@sinclair/typebox").TObject<{
        room_id: import("@sinclair/typebox").TUnsafe<import("@the-draupnir-project/matrix-basic-types").StringRoomID>;
        name: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TString, import("@sinclair/typebox").TNull]>>;
        topic: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TString, import("@sinclair/typebox").TNull]>>;
        avatar: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TString, import("@sinclair/typebox").TNull]>>;
        canonical_alias: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TUnsafe<import("@the-draupnir-project/matrix-basic-types").StringRoomAlias>, import("@sinclair/typebox").TString, import("@sinclair/typebox").TNull]>>;
        joined_members: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TNull]>>;
        joined_local_members: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TNull]>>;
        joined_local_devices: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TNull]>>;
        version: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TString, import("@sinclair/typebox").TNull]>>;
        creator: import("@sinclair/typebox").TTransform<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TNull, import("@sinclair/typebox").TString]>, import("@the-draupnir-project/matrix-basic-types").StringUserID | null>;
        encryption: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TString, import("@sinclair/typebox").TNull]>>;
        federatable: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TBoolean, import("@sinclair/typebox").TNull]>>;
        public: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TBoolean, import("@sinclair/typebox").TNull]>>;
        join_rules: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TLiteral<"public">, import("@sinclair/typebox").TLiteral<"knock">, import("@sinclair/typebox").TLiteral<"knock_restricted">, import("@sinclair/typebox").TLiteral<"invite">, import("@sinclair/typebox").TLiteral<"private">, import("@sinclair/typebox").TLiteral<"restricted">, import("@sinclair/typebox").TString, import("@sinclair/typebox").TNull]>>;
        guest_access: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TLiteral<"can_join">, import("@sinclair/typebox").TLiteral<"forbidden">, import("@sinclair/typebox").TNull]>>;
        history_visibility: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TLiteral<"invited">, import("@sinclair/typebox").TLiteral<"joined">, import("@sinclair/typebox").TLiteral<"shared">, import("@sinclair/typebox").TLiteral<"world_readable">, import("@sinclair/typebox").TNull]>>;
        state_events: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TNull]>>;
        room_type: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TString, import("@sinclair/typebox").TNull]>>;
        forgotten: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TBoolean, import("@sinclair/typebox").TNull]>>;
    }>>;
    offset: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TNull]>>;
    total_rooms: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TNull]>>;
    next_batch: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TNull]>>;
    prev_batch: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TNumber, import("@sinclair/typebox").TNull]>>;
}>;
//# sourceMappingURL=RoomListEndpoint.d.ts.map