import { EDStatic } from '../Interface/Static';
export type MembershipEventUnsigned = EDStatic<typeof MembershipEventUnsigned>;
export declare const MembershipEventUnsigned: import("@sinclair/typebox").TIntersect<[import("@sinclair/typebox").TObject<{
    age: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TNumber>;
    redacted_because: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnknown>;
    transaction_id: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TString>;
    prev_content: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnknown>;
}>, import("@sinclair/typebox").TObject<{
    invite_room_state: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TObject<{
        content: import("@sinclair/typebox").TUnknown;
        state_key: import("@sinclair/typebox").TString;
        type: import("@sinclair/typebox").TString;
        sender: import("@sinclair/typebox").TUnsafe<import("@the-draupnir-project/matrix-basic-types").StringUserID>;
    }>>>;
    knock_room_state: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TObject<{
        content: import("@sinclair/typebox").TUnknown;
        state_key: import("@sinclair/typebox").TString;
        type: import("@sinclair/typebox").TString;
        sender: import("@sinclair/typebox").TUnsafe<import("@the-draupnir-project/matrix-basic-types").StringUserID>;
    }>>>;
}>]>;
export type MembershipEventContent = EDStatic<typeof MembershipEventContent>;
export declare const MembershipEventContent: import("@sinclair/typebox").TObject<{
    avatar_url: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TString>;
    displayname: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TString, import("@sinclair/typebox").TNull]>>;
    membership: import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TLiteral<"invite">, import("@sinclair/typebox").TLiteral<"join">, import("@sinclair/typebox").TLiteral<"knock">, import("@sinclair/typebox").TLiteral<"leave">, import("@sinclair/typebox").TLiteral<"ban">]>;
    is_direct: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TBoolean>;
    join_authorised_via_users_server: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TString>;
    reason: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TString>;
    third_party_invite: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
        display_name: import("@sinclair/typebox").TString;
        signed: import("@sinclair/typebox").TObject<{
            mxid: import("@sinclair/typebox").TString;
            signatures: import("@sinclair/typebox").TUnknown;
            token: import("@sinclair/typebox").TString;
        }>;
    }>>;
}>;
export type BaseMembershipEvent = EDStatic<typeof BaseMembershipEvent>;
export declare const BaseMembershipEvent: import("@sinclair/typebox").TIntersect<[import("@sinclair/typebox").TIntersect<[import("@sinclair/typebox").TIntersect<[import("@sinclair/typebox").TIntersect<[import("@sinclair/typebox").TObject<{
    content: import("@sinclair/typebox").TObject<{}>;
}>, import("@sinclair/typebox").TObject<{
    event_id: import("@sinclair/typebox").TUnsafe<import("@the-draupnir-project/matrix-basic-types").StringEventID>;
    sender: import("@sinclair/typebox").TUnsafe<import("@the-draupnir-project/matrix-basic-types").StringUserID>;
    origin_server_ts: import("@sinclair/typebox").TNumber;
}>]>, import("@sinclair/typebox").TObject<{
    room_id: import("@sinclair/typebox").TUnsafe<import("@the-draupnir-project/matrix-basic-types").StringRoomID>;
}>]>, import("@sinclair/typebox").TObject<{}>]>, import("@sinclair/typebox").TObject<{
    state_key: import("@sinclair/typebox").TUnsafe<import("@the-draupnir-project/matrix-basic-types").StringUserID>;
    type: import("@sinclair/typebox").TLiteral<"m.room.member">;
    unsigned: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TIntersect<[import("@sinclair/typebox").TObject<{
        age: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TNumber>;
        redacted_because: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnknown>;
        transaction_id: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TString>;
        prev_content: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnknown>;
    }>, import("@sinclair/typebox").TObject<{
        invite_room_state: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TObject<{
            content: import("@sinclair/typebox").TUnknown;
            state_key: import("@sinclair/typebox").TString;
            type: import("@sinclair/typebox").TString;
            sender: import("@sinclair/typebox").TUnsafe<import("@the-draupnir-project/matrix-basic-types").StringUserID>;
        }>>>;
        knock_room_state: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TObject<{
            content: import("@sinclair/typebox").TUnknown;
            state_key: import("@sinclair/typebox").TString;
            type: import("@sinclair/typebox").TString;
            sender: import("@sinclair/typebox").TUnsafe<import("@the-draupnir-project/matrix-basic-types").StringUserID>;
        }>>>;
    }>]>>;
}>]>;
export type MembershipEvent = EDStatic<typeof MembershipEvent>;
export declare const MembershipEvent: import("@sinclair/typebox").TIntersect<[import("@sinclair/typebox").TIntersect<[import("@sinclair/typebox").TIntersect<[import("@sinclair/typebox").TIntersect<[import("@sinclair/typebox").TIntersect<[import("@sinclair/typebox").TObject<{}>, import("@sinclair/typebox").TObject<{
    event_id: import("@sinclair/typebox").TUnsafe<import("@the-draupnir-project/matrix-basic-types").StringEventID>;
    sender: import("@sinclair/typebox").TUnsafe<import("@the-draupnir-project/matrix-basic-types").StringUserID>;
    origin_server_ts: import("@sinclair/typebox").TNumber;
}>]>, import("@sinclair/typebox").TObject<{
    room_id: import("@sinclair/typebox").TUnsafe<import("@the-draupnir-project/matrix-basic-types").StringRoomID>;
}>]>, import("@sinclair/typebox").TObject<{}>]>, import("@sinclair/typebox").TObject<{
    type: import("@sinclair/typebox").TLiteral<"m.room.member">;
    unsigned: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TIntersect<[import("@sinclair/typebox").TObject<{
        age: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TNumber>;
        redacted_because: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnknown>;
        transaction_id: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TString>;
        prev_content: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnknown>;
    }>, import("@sinclair/typebox").TObject<{
        invite_room_state: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TObject<{
            content: import("@sinclair/typebox").TUnknown;
            state_key: import("@sinclair/typebox").TString;
            type: import("@sinclair/typebox").TString;
            sender: import("@sinclair/typebox").TUnsafe<import("@the-draupnir-project/matrix-basic-types").StringUserID>;
        }>>>;
        knock_room_state: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TArray<import("@sinclair/typebox").TObject<{
            content: import("@sinclair/typebox").TUnknown;
            state_key: import("@sinclair/typebox").TString;
            type: import("@sinclair/typebox").TString;
            sender: import("@sinclair/typebox").TUnsafe<import("@the-draupnir-project/matrix-basic-types").StringUserID>;
        }>>>;
    }>]>>;
    state_key: import("@sinclair/typebox").TUnsafe<import("@the-draupnir-project/matrix-basic-types").StringUserID>;
}>]>, import("@sinclair/typebox").TObject<{
    content: import("@sinclair/typebox").TObject<{
        avatar_url: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TString>;
        displayname: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TString, import("@sinclair/typebox").TNull]>>;
        membership: import("@sinclair/typebox").TUnion<[import("@sinclair/typebox").TLiteral<"invite">, import("@sinclair/typebox").TLiteral<"join">, import("@sinclair/typebox").TLiteral<"knock">, import("@sinclair/typebox").TLiteral<"leave">, import("@sinclair/typebox").TLiteral<"ban">]>;
        is_direct: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TBoolean>;
        join_authorised_via_users_server: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TString>;
        reason: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TString>;
        third_party_invite: import("@sinclair/typebox").TOptional<import("@sinclair/typebox").TObject<{
            display_name: import("@sinclair/typebox").TString;
            signed: import("@sinclair/typebox").TObject<{
                mxid: import("@sinclair/typebox").TString;
                signatures: import("@sinclair/typebox").TUnknown;
                token: import("@sinclair/typebox").TString;
            }>;
        }>>;
    }>;
}>]>;
//# sourceMappingURL=MembershipEvent.d.ts.map