import EventEmitter from 'events';
import { SetMembershipRevisionIssuer } from '../Membership/SetMembershipRevisionIssuer';
import { PolicyListRevisionIssuer } from '../PolicyList/PolicyListRevisionIssuer';
import { MembershipPolicyRevisionDelta, SetMembershipPolicyRevision } from './MembershipPolicyRevision';
export type SetMembershipPolicyRevisionListener = (nextRevision: SetMembershipPolicyRevision, changes: MembershipPolicyRevisionDelta, previousRevision: SetMembershipPolicyRevision) => void;
export interface SetMembershipPolicyRevisionIssuer {
    readonly currentRevision: SetMembershipPolicyRevision;
    on(event: 'revision', listener: SetMembershipPolicyRevisionListener): this;
    off(event: 'revision', listener: SetMembershipPolicyRevisionListener): this;
    emit(event: 'revision', ...args: Parameters<SetMembershipPolicyRevisionListener>): boolean;
    unregisterListeners(): void;
}
export declare class StandardMembershipPolicyRevisionIssuer extends EventEmitter implements SetMembershipPolicyRevisionIssuer {
    private readonly setMembershipRevisionIssuer;
    private readonly policyRevisionIssuer;
    currentRevision: SetMembershipPolicyRevision;
    private readonly setMembershipRevisionListener;
    private readonly policyRevisionListener;
    constructor(setMembershipRevisionIssuer: SetMembershipRevisionIssuer, policyRevisionIssuer: PolicyListRevisionIssuer);
    private setMembershipRevision;
    private policyRevision;
    unregisterListeners(): void;
}
//# sourceMappingURL=SetMembershipPolicyRevisionIssuer.d.ts.map