"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MjolnirEnabledProtectionsDescription = void 0;
// SPDX-FileCopyrightText: 2024 Gnuxie <Gnuxie@protonmail.com>
//
// SPDX-License-Identifier: AFL-3.0
const typebox_1 = require("@sinclair/typebox");
const describeConfig_1 = require("../../Config/describeConfig");
const SchemedMatrixData_1 = require("../../Interface/SchemedMatrixData");
exports.MjolnirEnabledProtectionsDescription = (0, describeConfig_1.describeConfig)({
    schema: typebox_1.Type.Object({
        enabled: typebox_1.Type.Array(typebox_1.Type.String(), { default: [], uniqueItems: true }),
        [SchemedMatrixData_1.DRAUPNIR_SCHEMA_VERSION_KEY]: typebox_1.Type.Optional(typebox_1.Type.Number()),
    }, { title: 'EnabledProtectionsConfig' }),
});
//# sourceMappingURL=MjolnirEnabledProtectionsDescription.js.map